//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ICSP_Main.h"
#include "ICSP_Option.h"
#include "MemViewWindow.h"
#include "ICSP_Process.h"
#include "common_var.h"
#include "mem_operate.h"
DynamicArray<Byte> dynFileArr; // convert function used
DynamicArray<Byte> dynICFlashSize;
DynamicArray<Byte> dynICEEPROMSize;
//
structBURN BURN_INFO;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SPComm"
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{

}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnSetClick(TObject *Sender)
{
frmICSP_Option->Show();
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnSetSysClick(TObject *Sender)
{
frmICSP_Option->Show();
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnFileOpenClick(TObject *Sender)
{
int i;
for (i=0; i<dynFileArr.Length; i++)
     dynFileArr[i] = 0xFF;

OpenBurnFile();

dynICFlashSize.Length = dynFileArr.Length;

String strS;

for (i=0; i<dynICFlashSize.Length; i++)
     dynICFlashSize[i] = dynFileArr[i];


ShowFileInfo();
}
//---------------------------------------------------------------------------
// TX
void MessageOut(AnsiString strMsg)
{
frmMain->stbMessage->Panels->Items[0]->Text = strMsg;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
// PIC16F877 flash size & eeprom size
BURN_INFO.IC_iFlashSize = 8192;
BURN_INFO.IC_iEepromSize = 256;
// allocation buffer size
dynFileArr.Length = BURN_INFO.IC_iFlashSize;
dynICFlashSize.Length = BURN_INFO.IC_iFlashSize;
dynICEEPROMSize.Length = BURN_INFO.IC_iEepromSize;
int i;
// clear buffer
for (i=0; i<BURN_INFO.IC_iFlashSize; i++) {
   dynFileArr[i] = 0xFF;
   dynICFlashSize[i] = 0xFF;
   }
for (i=0; i<BURN_INFO.IC_iEepromSize; i++)
   dynICEEPROMSize[i] = 0xFF;
}
//---------------------------------------------------------------------------
void ShowFileInfo(void)
{
String strTmp;
strTmp = BURN_INFO.FILE_strFilePath;
frmMain->mnoFileInfo->Text =
"ɮצmG" + strTmp + '\r' + '\n' +
"ɮפjpG" + PlusFileSizeComma() + " Bytes";

}
//---------------------------------------------------------------------------
// ɮפjpdƥ[Wr
String PlusFileSizeComma(void)
{
int i;
String strTmp;
strTmp = IntToStr(BURN_INFO.FILE_iFileSize);
i = strTmp.Length();
if (i > 3) {
   i -= 3;
   strTmp = strTmp.Insert(',', i+1);
   }
return strTmp;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnMemViewClick(TObject *Sender)
{

ShowFlash_8Byte(0);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::Button1Click(TObject *Sender)
{

frmProcess->Show();
}
//---------------------------------------------------------------------------

